=== examples/simple-hello/Makefile ===
hello:
	gcc -o $@ hello.c

install:
	install -Dm755 hello ${DESTDIR}/usr/bin/hello
